<tw_ethereum_wallet>
    <div class="content-block-title">Balance 帳戶餘額</div>
    <div class="content-block" style="text-align: right;"><span style="font-size: 1.5em">{numeral(tagRegister.tw_profile_balance.profile.ex_c_wallet_balance).format("0,0.00")}</span> <span style="font-size: 0.8em;">USD</span><hr/></div>
    <div class="content-block-title" if="{profile.eth_account}">Ethereum 以太幣餘額</div>
    <div class="content-block inset" style="text-align: right; background: rgba(255,255,255,0.9); padding-top: 1em; padding-bottom: 1em;" if="{profile.ethereum_account}" style="color:#ffef00">
        <span style="font-size: 1.5em;color:#deaa26;">{numeral(totalBalance).format("0,0.000000000000000")}</span> <span style="font-size: 0.8em; color:#deaa26;">ETH</span><br/>
        <span style="font-size: 1.2em;color:#deaa26;">( {numeral(totalBalance*exchangeRateInfo.price_usd).format("0,0.00")} ) USD</span>
<!--        <hr/>-->
    </div>
    <div class="content-block-title" if="{profile.ethereum_account || profile.eth_account}">ETH 以太幣位址</div>
    <div class="list-block inset" if="{profile.ethereum_account || profile.eth_account}">
        <ul>
            <li>
                <div class="item-content">
                    <div class="item-media"><i class="fab fa-ethereum" aria-hidden="true"></i></div>
                    <div class="item-inner">
                        <div class="item-input">
                            <input class="eth_address" type="text" name="eth_address" placeholder="Eth Coin Address 以太幣位址" required="" value="{'0x' + (profile.ethereum_account || profile.eth_account).replace('0x', '')}" onclick="{copyEthAddress}" disabled>
                        </div>
                    </div>
                </div>
            </li>
            <li>
                <a id="ethAddress" data-clipboard-text="{profile.ethereum_account || profile.eth_account}" href="#" class="button button-big active" onclick="{copyEthAddress}" style="background: {MAJOR_COLOR}; border-color: {MAJOR_COLOR};"><i1-8n>Copy</i1-8n></a>
            </li>
        </ul>
    </div>
    <div class="content-block-title">1 ETH = {numeral(exchangeRateInfo.price_usd).format("0,0.000")} USD</div>
    <div class="content-block" if="{!profile.ethereum_account && !profile.eth_account}">
        <p><a href="#" class="button button-big active" onclick="{createEthAccount}" style="background: {MAJOR_COLOR}; border-color: {MAJOR_COLOR};"><i1-8n>啟用以太錢包</i1-8n></a></p>
        <div class="progressbar">
            <span></span>
        </div>
    </div>
    
    <div class="content-block">
        <p><a href="#" class="button button-big active" onclick="{exchange}" style="background: {MAJOR_COLOR}; border-color: {MAJOR_COLOR};"><i1-8n>Menu</i1-8n></a></p>
    </div>
    
    <div class="content-block">
        <p><a href="#" class="button button-big active" onclick="{transactions}" style="background: {MAJOR_COLOR}; border-color: {MAJOR_COLOR};"><i1-8n>Transaction History</i1-8n></a></p>
    </div>
    

    <style>
        .fa, .fab{
            width: 1.5em;
            text-align: center;
            color: #9bb2cc;
        }
        page_form a {
            cursor: pointer;
        }
    </style>
    <script>
        var tag = this;
        tag.cmpName = "tw_ethereum_wallet";
        tag.profile = {};
        tag.exchangeRateInfo = {};
        tag.progressbarPercentage = 0;
        tag.progressbarTimer = null;
        tag.totalBalance = 0;
        tag.on("mount", function(){
            tagRegister[tag.cmpName] = this;
            if ( localStorage.getItem("totalBalance") == null )
                tag.totalBalance = tagRegister.tw_profile_balance.profile.eth_balance*1;
            else
                tag.totalBalance = localStorage.getItem("totalBalance");
            tag.loadData();
        });
        tag.loadData = function(){
            $.get(API_ENDPOINT+"/proxy/ethereum/exchange/rate", function(data){
//                console.log(data);
                if ( data.length > 0 ){
                    tag.exchangeRateInfo = data[0];
                    tag.update();
                }
            });
            $.get(API_ENDPOINT+"/members/"+topWebStorage.getItem("UserId"), function(data){
                tag.profile = data[0];
                console.log(tag.profile);
                if (false){
                // if ( tag.profile.eth_wallet_ver != 1){
                    window.location.href="/zenlet?token=eth";
                }else{
                    tag.update();
                    new Clipboard("#ethAddress");
                    $.ajax({
                        "url": API_ENDPOINT+"/ethereum/wallet/balance/mixed/"+topWebStorage.getItem("UserId"),
                        "method": "GET",
                        "timeout": 5*60*1000,
                        "success": function(_data){
                            tag.totalBalance = _data.balance;
                            tag.update();
                            localStorage.setItem("totalBalance", tag.totalBalance);
                        },
                        "statusCode": {
                            404: function(_data){
                                // App.alert('User Account Not Exists. <br/>使用者帳戶不存在，請先申請開通', 'Oops...');
                            },
                            502: function(_data){
                                App.alert('External Error. <br/>暫時無法同步主鏈資訊', 'Oops...發生錯誤');
                            }
                        }
                    });
                }
            });
        }
        tag.exchange = function(){
			var walletButtons = [{
                    text: i18n.localise("交易轉換"),
                    label: true
                },
				{
					text: "<span style='color: "+MAJOR_COLOR+"'>"+i18n.localise("Buy ETH")+"</span>", 
					onClick: function(){
						tagRegister.tw_cmp.loadCmp("tw_ethereum_stripe");
            		}
				},
				{
					text: "<span style='color: "+MAJOR_COLOR+"'>"+i18n.localise("Send ETH")+"</span>", 
					onClick: function(){
						tagRegister.tw_cmp.loadCmp("tw_ethereum_outward");
            		}
				},
                {
					text: "<span style='color: "+MAJOR_COLOR+"'>"+i18n.localise("Buy Authority Chips")+"</span>", 
					onClick: function(){
						tagRegister.tw_cmp.loadCmp("tw_transfer_eth_to_b_wallet");
            		}
				}
			];
//			
            var ctlButtons = [{
                text: i18n.localise("Cancel"),
                color: 'red'
            }];
			
            App.actions([ walletButtons, ctlButtons]);
		}
        
        tag.createEthAccount = function(){
            App.alert("建立以太錢包帳號約需花費1~3分鐘，建立過程中，請勿關閉畫面", "ETHEREUM", function(){
                App.showIndicator();
                
                tag.progressbarTimer = setInterval(function(){
                    App.showProgressbar($(".progressbar"), ++tag.progressbarPercentage, 'yellow');
                }, 3000);

                $.ajax({
                    // "url": API_ENDPOINT+"/ethereum/wallet/" + topWebStorage.getItem("UserId"),
                    // "method": "post",
                    "url": API_ENDPOINT+"/wallet/account/" + topWebStorage.getItem("UserId") + "/eth",
                    "method": "get",
                    "timeout": 5*60*1000,
                    "success": function(_data){
                        clearInterval(tag.progressbarTimer);
                        App.hideIndicator();
                        tag.loadData();
                        App.alert('Welcome To Be Our Members. <br/>歡迎使用以太錢包', 'SUCCESS', function(){
                            App.hideIndicator();
                        });
                    },
                    "statusCode": {
                        460: function(_data){
                            App.hideIndicator();
                            App.alert('User Does Not Exists. <br/>使用者不存在', 'Oops...發生錯誤');
                            clearInterval(tag.progressbarTimer);
                        },
                        461: function(_data){
                            App.hideIndicator();
                            App.alert('Can Not Found Referral Member. <br/>介紹人不存在', 'Oops...發生錯誤');
                            clearInterval(tag.progressbarTimer);
                        },
                        462: function(_data){
                            App.hideIndicator();
                            App.alert('Insufficient balance. <br/>帳戶餘額不足', 'Oops...發生錯誤');
                            clearInterval(tag.progressbarTimer);
                        },
                        463: function(_data){
                            App.hideIndicator();
                            App.alert('Account Already Exists. <br/>帳號已存在', 'Oops...發生錯誤');
                            clearInterval(tag.progressbarTimer);
                        },
                        500: function(_data){
                            App.hideIndicator();
                            App.alert('Internal Error. <br/>帳號建立失敗', 'Oops...發生錯誤');
                            clearInterval(tag.progressbarTimer);
                        }
                    }
                });
            });
        }
        tag.copyEthAddress = function(){
            App.addNotification({
                title: "Copy",
                message: "複製完成",
                hold: 3000
            });
            tagRegister.tw_cmp.loadCmp("tw_qrcode_generator", {data: '0x' + tag.profile.ethereum_account.replace('0x', '')});
        }
        tag.transactions = function(){
            tagRegister.tw_cmp.loadCmp("tw_ethereum_transactions");
        }
    </script>
</tw_ethereum_wallet>